//
// APIError.swift
//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import JSONUtilities

public enum APIError: Error {
    case unexpectedStatusCode(statusCode: Int, data: Data)
    case jsonDeserializationError(JSONUtilsError)
    case decodingError(DecodingError)
    case invalidBaseURL(String)
    case authorizationError(AuthorizationError)
    case networkError(Error)
    case unknownError(Error)
}

extension APIError: CustomStringConvertible {

    public var description:String {
        switch self {
        case .unexpectedStatusCode(let statusCode, _): return "Unexpected status code \(statusCode)"
        case .jsonDeserializationError(let error): return "\(error)"
        case .decodingError(let error): return error.description
        case .invalidBaseURL(let url): return "Invalid base URL \"\(url)\""
        case .authorizationError(let error): return "Failed to authorize: \(error.reason)"
        case .networkError(let error): return "Network error: \(error.localizedDescription)"
        case .unknownError(let error): return "Unknown error \(error.localizedDescription)"
        }
    }
}
